#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <wait.h>
#include <pthread.h>
#include <string.h>

#define print(...) do{printf(__VA_ARGS__); fflush(stdout); } while(0)

typedef unsigned char byte;
typedef int error_code;

#define ERROR (-1)
#define HAS_ERROR(code) ((code) < 0)
#define HAS_NO_ERROR(code) ((code) >= 0)
#define MAX_LINE_LENGTH (22)

int value = 0;

void *runner1(void *param);

int ex1() {
    pid_t pid;
    pthread_t tid;
    pthread_attr_t attr;
    pid = fork();
    if (pid == 0) {
        pthread_attr_init(&attr);
        pthread_create(&tid, &attr, runner1, NULL);
        pthread_join(tid, NULL);
        printf("LINE A value = %d\n", value);
    } else if (pid > 0) {
        wait(NULL);
        printf("LINE B value = %d\n", value);
    }
    printf("LINE C value = %d\n", value);

}

void *runner1(void *param) {
    value = 5;
    pthread_exit(0);
}

void *runner2(void *param);

int ex2() {
    value = 0;
    pid_t pid;
    pthread_t tid;
    pthread_attr_t attr;
    pid = fork();
    if (pid == 0) {
        pthread_attr_init(&attr);
        pthread_create(&tid, &attr, runner2, NULL);
        pthread_join(tid, NULL);
        printf("LINE A value = %d\n", value);
        char buffer[100];
        sprintf(buffer, "LINE B value = %d", value);
        execlp("echo", "echo", buffer, NULL);
        printf("LINE C value = %d\n", value);
    } else if (pid > 0) {
        wait(NULL);
        printf("LINE D value = %d\n", value);
    }
    printf("LINE E value = %d\n", value);

}

void *runner2(void *param) {
    value += 5;
    pthread_exit(0);
}


void *runner3(void *param);

int ex3() {
    value = 0;
    pid_t pid;
    pthread_t tid;
    pthread_attr_t attr;
    pid = fork();
    if (pid == 0) {
        pthread_attr_init(&attr);
        pthread_create(&tid, &attr, runner3, NULL);
        pthread_join(tid, NULL);
        printf("LINE A value = %d\n", value);
    } else if (pid > 0) {
        wait(NULL);
        printf("LINE D value = %d\n", value);
    }
    printf("LINE E value = %d\n", value);

}

void *runner3(void *param) {
    value += 5;
    char buffer[100];
    sprintf(buffer, "LINE C value = %d", value);
    execlp("echo", "echo", buffer, NULL);
    pthread_exit(0);
}

void *reverser(void *param);

char **reverser_args;
void consumer() {
    reverser_args = malloc(sizeof(char *) * 2);
    reverser_args[0] = "";
    reverser_args[1] = "";

    pthread_t tid_0;  //ID du thread
    pthread_attr_t attr_0;   // attributs du thread

    pthread_attr_init(&attr_0);   // initie les attributs
    int arg0 = 0;
    pthread_create(&tid_0, &attr_0, reverser, &arg0); //une fois qu'on les a, creer les thread

    pthread_t tid_1;  //ID du thread
    pthread_attr_t attr_1;   // attributs du thread

    pthread_attr_init(&attr_1);   // initie les attributs
    int arg1 = 1;
    pthread_create(&tid_1, &attr_1, reverser, &arg1); //une fois qu'on les a, creer les thread

    const char *const arr[] = {"foo", "bar", "sup guys!"};

    srand(time(NULL));   // Initialization, should only be called once.


    char **consumer_1 = malloc(sizeof(char *) * 10);

    for (int i = 0; i < 10; i++) {
        consumer_1[i] = malloc(sizeof(char) * 11); // plus gros string + 2 NULL

        strcpy(consumer_1[i], arr[rand() % 3]);

        int r_id = rand() %2;

        while (strlen(reverser_args[r_id]) != 0);
        reverser_args[r_id] = consumer_1[i];
    }

    while (strlen(reverser_args[0]) != 0);
    while (strlen(reverser_args[1]) != 0);

    //cleanup
    for (int i = 0; i < 10; i++) {
        for (int j = 1; j < 10; j++) consumer_1[i][j - 1] = consumer_1[i][j];
    }

    for (int i = 0; i < 10; i++) print("%i: %s\n", i, consumer_1[i]);
}

void *reverser(void *param) {
    int my_id = *((int *) param);

    while (1) {
        int len;
        while ((len = strlen(reverser_args[my_id])) == 0);

        char rev[len+2];
        for(int i=0; i<len; i++) {
            if(i >= len-i) break;
            char a = reverser_args[my_id][i];
            char b = reverser_args[my_id][len-i];
            rev[i] = b;
            rev[len-i] = a;
        }
        rev[len+1] = NULL;
        rev[0] = NULL;

        for(int i=len+1; i>=0; i--) reverser_args[my_id][i] = rev[i];
    }
}

int main() {
    consumer();
    return 0;
}
